part of viltage;

class Display extends Stage {
  List<List<Entity>> entities;
  
  VilTAGE viltage;
  Display(VilTAGE viltage) : super(viltage.config.canvas) {
    this.viltage = viltage;
    entities = _fillEntityList(20);
    load();
    onEnterFrame.listen((EnterFrameEvent e) { _enter(e); });
    onExitFrame.listen((ExitFrameEvent e) { _exit(e); });
  }
  
  _enter(EnterFrameEvent e) {
    for(int i = 0; i < entities.length; i++) {
      for(int j = 0; j < entities[i].length; j++) {
        addChild(entities[i][j]);
      }
    }
  }
  
  _exit(ExitFrameEvent e) {
    removeChildren();
  }
  
  load() {  }
  remove() { }
  show() { }
  update(num fps) {
    for(int i = 0; i < entities.length; i++) {
      for(int j = 0; j < entities[i].length; j++) {
        entities[i][j].update(fps);
      }
    }
  }
  
  static List<List<Entity>> _fillEntityList(int layers) {
    List<List<Entity>> entities = new List<List<Entity>>();
    for(int i = 0; i < layers+1; i++) {
      entities.add(new List<Entity>());
    }
    return entities;
  }
}