library viltage;
import 'dart:html';
import 'dart:html' as HTML;
import 'package:stagexl/stagexl.dart';
import 'dart:async';

part 'viltage_config.dart';
part 'entity.dart';
part 'display.dart';
part 'input.dart';
part 'char_node.dart';
part 'state.dart';

class VilTAGE {
  VilTAGEConfig config;
  Input input;
  RenderLoop renderLoop;
  Display screen;
  
  /* Streams */
  StreamController _controllerUpdate = new StreamController();
  Stream onUpdate;
  
  VilTAGE(this.config) {
    renderLoop = new RenderLoop();
    screen = new Display(this);
    input = new Input();
    config.calculate();
    
    onUpdate = _controllerUpdate.stream;
  }
  
  setScreen(Display newScreen) {
    screen.remove();
    renderLoop.removeStage(screen);
    renderLoop.addStage(newScreen);
    screen = newScreen;
    newScreen.show();
    screen.onEnterFrame.listen((EnterFrameEvent e) {
      update(screen.frameRate);
      screen.update(screen.frameRate);
    });
  }
  
  update(num fps) {
    input.update();
    _controllerUpdate.add(fps);
  }
}